eval 'exec perl -S $0 ${1+"$@"}'  # -*- Mode: perl -*-
    if $running_under_some_shell;

#

use strict;
use Mail::Mailer;

require Exporter;
use Blowfish_PP;

our @ISA = qw(Exporter);
our @EXPORT = qw( db_connect db_disconnect);
our @EXPORT_OK = qw();
our $VERSION = 1.00;


# our $host_arch = $ENV{"EPICS_HOST_ARCH"};

my $host_arch = "linux-x86";

print "\n host arch: $host_arch \n";

# our $db_properties_path = "/your directory/epics/extensions/bin/$host_arch/nagios_db.properties";

# our $string = "your Nagios db string"; # defined for Nagios MySQL database 

print "\n db properites path: $db_properties_path \n";

my @row;
my $dbh;
my $mailmssg = "";
my $alarm_severity;
my $nagios_is_running;

   eval 'use DBI';
    if ( $@ ) {
       print "Couldn't load DBI.\n";
       return 0;
    }

    eval 'use DBD::mysql';
    if ( $@ ) {
       print "Couldn't load DBD::mysql.\n";
       return 0;
    }


   my $db_host;
   my $db_database;
   my $db_user;
   my $db_vendor;
   my $db_password;
   
   
    if (!-e $db_properties_path) {
       print("ERROR: Unable to find db.properties file\n");
       print("ERROR: Exiting...\n");
        exit(-1);
    }

    # Read in contents of db.properties
    my $blowfish_object;
    if ($string) {
        my $packed_key = pack("a16",$string);
        $blowfish_object = Crypt::Blowfish_PP->new($packed_key);
        if (!$blowfish_object) {
           print("ERROR: The given blowfish key appears to be invalid\n");
           print("ERROR: Exiting...\n");
            exit(-1);
        }
    }
    
   
    open(DBPROPS,$db_properties_path);
    my $inbuf;
    my $input_text;
    while (my $read_len = read(DBPROPS, $inbuf, 8)) {
        if ($blowfish_object) {
            my $decrypted_text = $blowfish_object->decrypt($inbuf);
            $input_text = $input_text . $decrypted_text;
        } else {
            $input_text = $input_text . $inbuf;
        }
    }
    
    print "Made it through Blowfish \n";
    
    close(DBPROPS);
    
    print "Parse the db properties text \n";

    # Parse up the db.properties text
    my $props_line;
    my $prop_name;
    my $prop_val;
    while ($input_text =~ /^([^\n]*)\n(.*)/s) {
        $props_line = $1;
        $input_text = $2;
        if ($props_line =~ /(.*)=(.*)/) {
            $prop_name = $1;
            $prop_val = $2;
            if ($prop_name eq "db.host") {
                $db_host = $prop_val;
            } elsif ($prop_name eq "db.database") {
                $db_database = $prop_val;
            } elsif ($prop_name eq "db.user") {
                $db_user = $prop_val;
            } elsif ($prop_name eq "db.password") {
                $db_password = $prop_val;
            } elsif ($prop_name eq "db.vendor") {
                # db_vendor is package global
                $db_vendor = $prop_val;
            }
        }
    }
    
    
    if (!$db_host || !$db_database || !$db_user || !$db_password ||!$db_vendor) {
       print("ERROR: Unable to read db connection parameters\n");
       print("ERROR: Exiting...\n");
        exit(-1);
    }


    # Get db vendor-specific DBI connect string
    my $dsn = "DBI:mysql:$db_database:$db_host";
    
    eval {
        $dbh = DBI->connect($dsn,$db_user,$db_password);
	
    };
    
  	
	
  if (!$dbh) {
    print("ERROR: Cannot connect to database.\n");
    print("ERROR: Exiting...\n");
    exit(-1);
  } else {
  
  	print "Nagios database connection made. \n";
  }

	# Determine if the Nagios software process is up and running
		my $is_currently_running = 0;
		my $sel = "SELECT is_currently_running FROM nagios_programstatus WHERE is_currently_running = 1;";
		my $sth = $dbh->prepare("$sel");
		  $sth->execute() or die "Couldn't execute statement: " . $dbh->errstr;
		
		  while (@row = $sth->fetchrow_array()) {
		    $is_currently_running = $row[0];
		    
		  }

		 if (!$is_currently_running) {

					$mailmssg = "WARNING: Nagios Program is not currently running.\n";
		 }else {
		 	print "Nagios program is running.\n";
		 }
		

        # Retrieve list of Nagios:
        #
        #  Host Groups (alias name)
        #  Service Status Summary (OK, UNKNOWN, CRITICAL, PENDING)

        my $service_status_total_ok = 0;
        my $service_status_total_warning = 0;
        my $service_status_total_critical = 0;
        my $service_status_total_unknown = 0;

        # Query for Nagios Host Groups

        $sel = 'select alias, hostgroup_id from nagios_hostgroups;';
	$sth = $dbh->prepare("$sel");
	$sth->execute() or die "Couldn't execute statement: " . $dbh->errstr;
		
	while (@row = $sth->fetchrow_array()) {
       

        		my $hostgroup_name_previous = "";

        		my $hostgroup_name = $row[0];
        		my $hostgroup_id = $row[1];

        		# echo "host group id:".$hostgroup_id."</br>";

        		if ($hostgroup_name) {

					# Strip off ending '_host_group'

					my $end = index($hostgroup_name,'_host_group');

					if ($end > 1) {
						$hostgroup_name = substr($hostgroup_name,0,$end);
					}

					$hostgroup_name = uc($hostgroup_name);

	            	# Query for COUNT on services current state for each Nagios host group

			    	my $sqlCurrentStates = "select distinct nagios_servicestatus.current_state, count(*) as state_total
				from nagios_servicestatus, nagios_hostgroups, nagios_hostgroup_members, nagios_services where
				nagios_hostgroups.hostgroup_id = $hostgroup_id and nagios_hostgroups.hostgroup_id =
				nagios_hostgroup_members.hostgroup_id and nagios_hostgroup_members.host_object_id =
				nagios_services.host_object_id and nagios_services.service_object_id =
				nagios_servicestatus.service_object_id
				and nagios_servicestatus.service_object_id 
				NOT IN (select nagios_comments.object_id from nagios_comments where nagios_comments.is_persistent = 1)
				group by nagios_servicestatus.current_state;";

				my $sthCurrentStates = $dbh->prepare("$sqlCurrentStates");
				$sthCurrentStates->execute() or die "Couldn't execute statement: " . $dbh->errstr;
							
		  		while (@row = $sthCurrentStates->fetchrow_array()) {

							my $alarm_severity = $row[0];
							my $alarm_count = $row[1];

							# Convert alarm severity to text

							if ($alarm_severity ==1){
								  # WARNING
								  
								  $service_status_total_warning = $service_status_total_warning + $alarm_count;
							}
							if ($alarm_severity ==2){
								  # CRITICAL
								  
								  $service_status_total_critical = $service_status_total_critical + $alarm_count;
								  }
							if ($alarm_severity ==3){
								  # UNKNOWN
								  
								  $service_status_total_unknown = $service_status_total_unknown + $alarm_count;
								  }
							if ($alarm_severity == 0){
								  # OK
								  
								  $service_status_total_ok = $service_status_total_ok + $alarm_count;
								  }
                					

                		}  
					
			} 

	    	} 

	    
	    	#Print service status totals to email message
		
		my $current_time = localtime();
		
		$mailmssg = "Controls IMS Status Report at: $current_time\n";

	    	$mailmssg = $mailmssg."\nIMS Service Status Totals\nOK:     ".$service_status_total_ok."\n";
		$mailmssg = $mailmssg."WARNING:   ".$service_status_total_warning."\n";
		$mailmssg = $mailmssg."UNKNOWN:   ".$service_status_total_unknown."\n";
		$mailmssg = $mailmssg."ACTIVE CRITICAL:  ".$service_status_total_critical."\n";
		
		# $mailmssg = $mailmssg."\nNote: CRITICAL total above does not include services that have cognizant comments.\n";
		
		print "$mailmssg\n";
			
$dbh->disconnect() if $dbh;

print "\nBegin email message...\n";

my $mailer = Mail::Mailer->new("sendmail");


$mailer->open({From    => "quock\@aps.anl.gov",
              To      => "quock\@aps.anl.gov",
	      Cc      => "mailaps_con1\@anlmail.anl.gov",
	      Bcc      => "mailaps_con2\@anlmail.anl.gov",
              Subject => "APS Controls IMS Daily Reminder",
             }) or warn "Can't do the mail thing : $!";

print $mailer $mailmssg;
$mailer->close();

print "\nFinished email message.\n";
